; *******************************************************************************
; get part of a bitmap
;
; (softKUS) - VI/2004
; *******************************************************************************

.386
.MODEL FLAT

.CODE
_run:

include         ..\stdparas.inc                         ; PA1-PA4
include         ..\abpstruc.inc                         ; asmBmpPara-structure

; *********************************************************************************************

abp             EQU     <PA1>                           ; only src part needed
fct             EQU     <PA2>                           ; arr:lng X1/XN/Y1/YN

; *********************************************************************************************

bmpPart         PROC    NEAR
                mac     SAVE

init:           mov     ebx,fct
                mov     edi,[ebx]                       ; X1
                mov     ecx,[ebx+4]                     ; XN
                mov     eax,[ebx+8]                     ; Y1
                mov     edx,[ebx+12]                    ; YN
                
                mov     ebx,abp          
                mov     esi,srcWidthBytes
                
                or      edx,edx
                jg      init_1
                mov     edx,srcHeight
init_1:         or      eax,eax
                jl      fehler
                imul    esi,eax
                add     eax,edx
                sub     eax,srcHeight
                jbe     init_2
                sub     edx,eax
                jbe     fehler

init_2:         or      ecx,ecx
                jg      init_3
                mov     ecx,srcWidth
init_3:         mov     eax,edi
                or      eax,eax
                jl      fehler

                movzx   edi,srcBitsPixel
                shr     edi,3
                push    eax
                imul    eax,edi
                add     esi,eax
                add     esi,srcBits
                pop     eax
                add     eax,ecx
                sub     eax,srcWidth
                jbe     init_4
                sub     ecx,eax
                jbe     fehler

init_4:         mov     tgtWidth,ecx
                mov     tgtHeight,edx
                imul    ecx,edi
                add     ecx,3
                and     cl,0FCh
                mov     tgtWidthBytes,ecx
                mov     eax,srcWidthBytes
                sub     eax,ecx
                mov     edi,tgtBits
                shr     ecx,2
lpRow:          push    ecx
                rep     movsd
                pop     ecx
                add     esi,eax
                dec     edx
                jnz     lpRow
                stc
                jmp     finish

fehler:         clc
finish:         mac     REST
bmpPart         ENDP

END _run
